var _USE_WATERSHED = true;

straightenAndSeparate();
sortMeasurements();
countPerSegment() ;

function straightenAndSeparate() {
    run("Set Measurements...", "area centroid display redirect=None decimal=3");
    run("Z Project...", "projection=[Max Intensity]");
    waitForUser("Please make a selection!");
    run("Straighten...");
    setAutoThreshold("Default dark");
    run("Convert to Mask");
    if( _USE_WATERSHED) run("Watershed");
    run("Analyze Particles...", "size=20-100 show=Nothing display clear add");
}


function countPerSegment() {
    startX = 0;
    len = 200;
    counter = 0;
    segment = 1;
    height = getHeight();

    run("Remove Overlay");

    title1 = "Count per segment";
    title2 = "["+title1+"]";
    f = title2;
    if (isOpen(title1))
         print(f, "\\Clear");
    else
         run("Table...", "name="+title2+" width=250 height=600");
    print(f, "\\Headings:n\tsegment\tcount");

    for (i=0; i<nResults; i++) {
	x = getResult("X", i);
	if (x<startX + len) 
		counter++;
	else {
		xR = startX;
		toUnscaled(xR);
		lenR = len;
		toUnscaled(lenR);
		makeRectangle(xR, 0, lenR, height);
		run("Add Selection...");
		print(f, segment+"\t"+counter);
		counter = 0;
		segment++;
		startX = startX + len;
	}
    }
    run("Select None");
}

function sortMeasurements() {
    FEATURE = "X";
    REVERSE = false;

    column = newArray(nResults);
    for (i=0; i<nResults; i++) {
	column[i] = getResult(FEATURE, i);
    }
    positions = Array.rankPositions(column);
    if (REVERSE) Array.reverse(positions);
    ranks = Array.rankPositions(positions);
    
    for (i=0; i<roiManager("count"); i++) {
	roiManager("select", i);
	roiManager("Rename", IJ.pad(ranks[i], 4)); 
    }
    roiManager("Deselect");
    roiManager("Sort");
    selectWindow("Results");
    run("Close");
    roiManager("Show None");
    roiManager("Show All");
    roiManager("Measure");
}
